/*
    yasep/JSgui/yasep_messages.js
    created Sat Mar 5 23:33:09 EST 2005 by whygee@f-cpu.org

  version Wed Mar  9 18:41:30 EST 2005 : Object-Oriented re-shaping of the code
     in order to clean it up as much as possible.
  version Wed Jun  8 20:38:45 EDT 2005 : adding memory
  2 days later : moving memory to vsp_mem.js and the registers to vsp_reg.js
  version 2005-06-15 : updating the message queue's code and fixed int2hex
  version 2005-06-17 : message queue now looking much better and int2hex is re-fixed
  version 2005-06-19 : colors added to the messages
  version 2006-08-03 : added str2int() [and removed equivalent code from other places]
  version 2006-08-06 : split from VSP/vsp_arch.js
  version 2006-09-02 : moved to vspsim/JScore/
  version 2007-04-08 : new version with a better DOM behaviour,
                       which lets the broswser do the FIFO dance itself.
  version 2007-11-05 : rebranding to YASEP
  version 2009-07-09 : added conditional definition

 dependency : the HTML page +CSS must be properly setup
   and the "onload" JS must prepare various variables (notably "messages").

*/

var messages;      // HTML-ID of the message area
var msg_number=0;
var msg_list_depth=40;
var msg_new_div,msg_first_div,msg_last_div;

function define_messages(){
if (typeof add_message!='function') {

  reset_messages=function() {
    // flush the whole div :
    messages.innerHTML=""; // au revoir les divs, dites bonjour au ramasse-miettes !
    msg_number=0;
  }

  add_message=function(color, msg) {
    // color : severity of the message (blue, green, yellow, orange, red ...)
    // msg : displayed text

    msg_number++;
    var tmp='<span style="background-color:' + color + '">' + msg_number + '</span>: ' + msg + '<br>';

    if (msg_number==1) { // first message ?
      messages.innerHTML=""; // flush any speculative error message.
      msg_first_div=document.createElement('div');
      msg_first_div.innerHTML=tmp;
      messages.appendChild(msg_first_div);
      msg_last_div=msg_first_div;
    }
    else { // next message
      if (msg_number < msg_list_depth) {
        msg_new_div=document.createElement('div');
        msg_new_div.innerHTML=tmp;
        messages.insertBefore(msg_new_div,msg_last_div);
        msg_last_div=msg_new_div;
      }
      else {
        msg_new_div=msg_first_div;
        msg_first_div=msg_first_div.previousSibling;
        messages.removeChild(msg_new_div);
        msg_new_div.innerHTML=tmp;
        messages.insertBefore(msg_new_div,msg_last_div);
        msg_last_div=msg_new_div;
      }
    }
  }
} // /if

}

define_messages();
